//+------------------------------------------------------------------+
//|                                                 |
//|                                      DC2008 Copyright  2008-2009|
//+------------------------------------------------------------------+

#property indicator_chart_window

extern double  del.Timeperiod=300.0;//    
extern int     period.Bands=144;
extern int     period.MA=21;
extern bool    V.line=true;
extern bool    H.line=true;
extern bool    I.line=false;
extern bool    HiLo.line=false;
extern bool    P.point=true;

int            magic=1;
double         Bands.HIGH[2], Bands.LOW[2], MA[2];
double         P, M1, M0, R1, R0, X;
double         draw.Timeperiod=-240.0;//    
string         obj.name;
datetime       obj.time1, del.time1;

int init(){
   return(0);
}

int deinit(){
   Comment("");
   return(0);
}

int start(){
   Bands.HIGH[0]=iBands(NULL,0,period.Bands,2,0,PRICE_HIGH,MODE_UPPER,0);
   Bands.HIGH[1]=iBands(NULL,0,period.Bands,2,0,PRICE_HIGH,MODE_UPPER,1);
   Bands.LOW[0]= iBands(NULL,0,period.Bands,2,0,PRICE_LOW,MODE_LOWER,0);
   Bands.LOW[1]= iBands(NULL,0,period.Bands,2,0,PRICE_LOW,MODE_LOWER,1);
   MA[0]=iMA(NULL,0,period.MA,0,MODE_EMA,PRICE_CLOSE,0);
   MA[1]=iMA(NULL,0,period.MA,0,MODE_EMA,PRICE_CLOSE,1);
//+------------------------------------------------------------------+
   if(V.line)                                                        {
      ObjectCreate("V",OBJ_VLINE,0,0,0,0,0);
      ObjectSet("V",OBJPROP_TIME1,Time[0]);
      ObjectSet("V",OBJPROP_STYLE,STYLE_DASHDOTDOT);
      ObjectSet("V",OBJPROP_COLOR,Red);
      ObjectSet("V",OBJPROP_WIDTH,0);
   }
//+------------------------------------------------------------------+
   if(H.line)                                                        {
      obj.name="HI"+Period()+magic;
      ObjectCreate(obj.name,OBJ_HLINE,0,0,0,0,0);
      ObjectSet(obj.name,OBJPROP_PRICE1,Bands.HIGH[0]);
      ObjectSet(obj.name,OBJPROP_STYLE,STYLE_DOT);
      ObjectSet(obj.name,OBJPROP_COLOR,Red);
      ObjectSet(obj.name,OBJPROP_WIDTH,0);
      //+------------------------------------------------------------+
      obj.name="LO"+Period()+magic;
      ObjectCreate(obj.name,OBJ_HLINE,0,0,0,0,0);
      ObjectSet(obj.name,OBJPROP_PRICE1,Bands.LOW[0]);
      ObjectSet(obj.name,OBJPROP_STYLE,STYLE_DOT);
      ObjectSet(obj.name,OBJPROP_COLOR,Blue);
      ObjectSet(obj.name,OBJPROP_WIDTH,0);
   }
//+------------------------------------------------------------------+
//     .   -  
//+------------------------------------------------------------------+
   if(I.line)                                                        {
      obj.name="MA"+magic;
      ObjectCreate(obj.name,OBJ_TREND,0,0,0,0,0);
      ObjectSet(obj.name,OBJPROP_TIME1,Time[1]);
      ObjectSet(obj.name,OBJPROP_TIME2,Time[0]);
      ObjectSet(obj.name,OBJPROP_PRICE1,MA[1]);
      ObjectSet(obj.name,OBJPROP_PRICE2,MA[0]);
      ObjectSet(obj.name,OBJPROP_COLOR,Magenta);
      ObjectSet(obj.name,OBJPROP_WIDTH,0);
   }
//+------------------------------------------------------------------+
//     .   -  
//+------------------------------------------------------------------+
   if(HiLo.line)                                                     {
      obj.name="HI"+magic;
      ObjectCreate(obj.name,OBJ_TREND,0,0,0,0,0);
      ObjectSet(obj.name,OBJPROP_TIME1,Time[1]);
      ObjectSet(obj.name,OBJPROP_TIME2,Time[0]);
      ObjectSet(obj.name,OBJPROP_PRICE1,Bands.HIGH[1]);
      ObjectSet(obj.name,OBJPROP_PRICE2,Bands.HIGH[0]);
      ObjectSet(obj.name,OBJPROP_STYLE,STYLE_DASHDOT);
      ObjectSet(obj.name,OBJPROP_COLOR,Aqua);
      ObjectSet(obj.name,OBJPROP_WIDTH,0);
      //+------------------------------------------------------------+
      obj.name="LO"+magic;
      ObjectCreate(obj.name,OBJ_TREND,0,0,0,0,0);
      ObjectSet(obj.name,OBJPROP_TIME1,Time[1]);
      ObjectSet(obj.name,OBJPROP_TIME2,Time[0]);
      ObjectSet(obj.name,OBJPROP_PRICE1,Bands.LOW[1]);
      ObjectSet(obj.name,OBJPROP_PRICE2,Bands.LOW[0]);
      ObjectSet(obj.name,OBJPROP_STYLE,STYLE_DASHDOT);
      ObjectSet(obj.name,OBJPROP_COLOR,Aqua);
      ObjectSet(obj.name,OBJPROP_WIDTH,0);
   }
//+------------------------------------------------------------------+
   Comment("  DC2008    ", ObjectsTotal());
//+------------------------------------------------------------------+
//    
//+------------------------------------------------------------------+
   if(Minute()==0)                                                   {
      int obj.total=ObjectsTotal();
      del.time1=Time[0]-del.Timeperiod*60*Period();
      for(int i=0;i<obj.total;i++)                                   {
         obj.name=ObjectName(i);
         if(ObjectType(obj.name)==OBJ_ARROW)                         {
            obj.time1=ObjectGet(obj.name, OBJPROP_TIME1);
            if(obj.time1<del.time1)                                  {
               ObjectDelete(obj.name);
            }
         }
      }
   }
//+------------------------------------------------------------------+
   int GTC=GetTickCount();                                                    
//+------------------------------------------------------------------+
   if(P.point)                                                       {
      M1=Bands.HIGH[1]; 
      M0=Bands.HIGH[0];
      R1=MA[1]; 
      R0=MA[0];
      if(MathAbs((R0-R1)-(M0-M1))>0)                                 {
         P=M1+(M0-M1)*(M1-R1)/((R0-R1)-(M0-M1));
         X=(M1-R1)/((R0-R1)-(M0-M1));
         if(X>draw.Timeperiod)                                       {
            obj.time1=Time[0]+X*60*Period();
            obj.name="HIGH"+Period()+"P"+GTC+magic;
            ObjectCreate(obj.name,OBJ_ARROW,0,0,0,0,0);
            ObjectSet(obj.name,OBJPROP_TIME1,obj.time1);
            ObjectSet(obj.name,OBJPROP_PRICE1,P);
            ObjectSet(obj.name,OBJPROP_WIDTH,0);
            ObjectSet(obj.name,OBJPROP_COLOR,Red);
            ObjectSet(obj.name,OBJPROP_ARROWCODE,170);
            if(X<0)                                                  { 
               ObjectSet(obj.name,OBJPROP_ARROWCODE,178);
               ObjectSet(obj.name,OBJPROP_COLOR,Maroon);
            }
         }
      }
   }
//+------------------------------------------------------------------+
   if(P.point)                                                       {
      M1=Bands.LOW[1]; 
      M0=Bands.LOW[0];
      R1=MA[1]; 
      R0=MA[0];
      if(MathAbs((R0-R1)-(M0-M1))>0)                                 {
         P=M1+(M0-M1)*(M1-R1)/((R0-R1)-(M0-M1));
         X=(M1-R1)/((R0-R1)-(M0-M1));
         if(X>draw.Timeperiod)                                       {
            obj.time1=Time[0]+X*60*Period();
            obj.name="LOW"+Period()+"P"+GTC+magic;
            ObjectCreate(obj.name,OBJ_ARROW,0,0,0,0,0);
            ObjectSet(obj.name,OBJPROP_TIME1,obj.time1);
            ObjectSet(obj.name,OBJPROP_PRICE1,P);
            ObjectSet(obj.name,OBJPROP_WIDTH,0);
            ObjectSet(obj.name,OBJPROP_COLOR,Blue);
            ObjectSet(obj.name,OBJPROP_ARROWCODE,170);
            if(X<0)                                                  { 
               ObjectSet(obj.name,OBJPROP_ARROWCODE,178);
               ObjectSet(obj.name,OBJPROP_COLOR,DarkBlue);
            }
         }
      }
   }
//+------------------------------------------------------------------+
   return(0);
}

